/*
 * buffer_io.c - buffer io part of createrec-gtk
 * Copyright (c) 2009 Markus Kohm
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#include "buffer_io.h"

guint8 getgint8( const gint8 *packet ) {
    return *packet;
}

guint8 getguint8( const guint8 *packet ) {
    return *packet;
}

guint16 getguint16( const guint8 *packet ) {
    return ((guint16)(*packet) << 8) | packet[1];
}

guint16 getguint16c( const guint8 *packet ) {
    return *packet | ((guint16)(packet[1]) << 8);
}

guint32 getguint24( const guint8 *packet ) {
    return ((guint32)(*packet) << 16)
	| ((guint32)(packet[1]) << 8)
	| packet[2];
}

guint32 getguint32( const guint8 *packet ) {
    return ((guint32)(*packet) << 24) 
	| ((guint32)(packet[1]) << 16)
	| ((guint32)(packet[2]) << 8)
	| packet[3];
}

guint32 getguint32c( const guint8 *packet ) {
    return *packet
	| ((guint32)(packet[1]) << 8)
	| ((guint32)(packet[2]) << 16)
	| ((guint32)(packet[3]) << 24);
}

gboolean is_flagmask( guint8 flags, guint8 flagmask ) {
    return ( ( flags & flagmask ) == flagmask ) ? TRUE : FALSE;
}

gboolean is_flagatmask( guint8 flags, guint8 flagmask ) {
    return ( flags & flagmask ) ? TRUE : FALSE;
}

gboolean is_flagmask16( guint16 flags, guint16 flagmask ) {
    return ( ( flags & flagmask ) == flagmask ) ? TRUE : FALSE;
}

gboolean is_flagatmask16( guint16 flags, guint16 flagmask ) {
    return ( flags & flagmask ) ? TRUE : FALSE;
}
