/*
 * buffer_io.h - buffer io part of createrec-gtk
 * Copyright (c) 2009 Markus Kohm
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */

#ifndef __buffer_io_h
#include <glib.h>

/* Read a value in stream byte order from packet buffer */
guint8 getgint8( const gint8 *packet );

guint8 getguint8( const guint8 *packet );

guint16 getguint16( const guint8 *packet );

guint32 getguint24( const guint8 *packet );

guint32 getguint32( const guint8 *packet );

/* Read a value in Comag byte order from packet buffer */
#define getguint8c getguint8

guint16 getguint16c( const guint8 *packet );

guint32 getguint32c( const guint8 *packet );

/* Test flags */

gboolean is_flagmask( guint8 flags, guint8 flagmask );

gboolean is_flagatmask( guint8 flags, guint8 flagmask );

gboolean is_flagmask16( guint16 flags, guint16 flagmask );

gboolean is_flagatmask16( guint16 flags, guint16 flagmask );

#endif /* __buffer_io.h */
